<?php

ini_set('display_errors', 1);

require_once '../../../resources/base_path_include.php';
require_once $base_path_to_learning_resources  . "includes/connect.php"; // use require for mandatory files
require_once $base_path_to_learning_resources . 'lib/function.php';
require_once $base_path_to_learning_resources . 'lib/validate_api_signature.php';

//validation file
require_once $base_path_to_learning_resources . 'lib/validate_function.php';
require_once $base_path_to_learning . 'user_management/authenticate.php';
require_once $base_path_to_learning . 'functions/common_functions.php';
//db access function
require_once $base_path_to_learning_resources . 'includes/specific_db_config.php';

//aws image store
require_once $base_path_to_learning_resources . 'lib/common_modules/reminders/function_reminders.php';
require_once $base_path_to_learning . "faculty_api/faculty_function/common_faculty_function.php";
require_once $base_path_to_learning . "principal_api/principal_function/principal_function.php";


$postdata = json_decode(file_get_contents("php://input"), true);
checkIfNoPhpContentsReceive();


if (
    !isset($postdata['reminder_id']) or !checkIfIssetAndNotEmpty($postdata['reminder_id']) or
    !isset($postdata['function_type']) or !checkIfIssetAndNotEmpty($postdata['function_type'] or
        !isset($postdata['api_signature']) or !checkIfIssetAndNotEmpty($postdata['api_signature']) or
        !isset($postdata['jwt_token']) or !checkIfIssetAndNotEmpty($postdata['jwt_token']) or
        !isset($postdata['checked']) or !checkIfIssetAndNotEmpty($postdata['checked']))
) {
    errorreturn("All * fields are required.");
}
validateApiSignature($postdata['api_signature']);

$jwttoken = $postdata['jwt_token'];

$jwt_validate = authenticate_jwt($jwttoken);
$userid = $jwt_validate->data->id;
$workspace_id = $jwt_validate->data->workspace_id;
$username = $jwt_validate->data->username;
$role = $jwt_validate->data->role;
$institution_id = $jwt_validate->data->institution_id;
$branch_id = $jwt_validate->data->branch_id;

$specific_db_name = validateUserAccess($conn_rjllearning, $userid, $role, $workspace_id, ['teacher'], null);

if (!$specific_db_name) {
    errorreturn('Access denied.');
} else {
    $conn_rjllearning_specific = dynamicDbConnection($specific_db_name);
}
require_once $base_path_to_learning . 'user_management/user_versioning.php';

$version = isset($_POST['version']) ? $_POST['version'] : (isset($postdata['version']) ? $postdata['version'] : null);
$updated_time = isset($_POST['updated_time']) ? $_POST['updated_time'] : (isset($postdata['updated_time']) ? $postdata['updated_time'] : null);

$response = user_data_refresh($conn_rjllearning,$conn_rjllearning_specific, $version, $updated_time, $userid, $institution_id);


$reminder_id = $postdata['reminder_id'];
$checked = $postdata['checked'];

if ($postdata['checked'] != 1 && $postdata['checked'] != 0) {
    errorreturn("Access denied.");
}
$sql_faculty = $conn_rjllearning_specific->prepare("SELECT id FROM faculty_info WHERE userid = ? AND institution_id = ? AND branch_id = ?");
$sql_faculty->execute([$userid, $institution_id, $branch_id]);
$result_faculty = $sql_faculty->fetch(PDO::FETCH_ASSOC);
if (!$result_faculty) {
    errorreturn("Faculty not found.");
}

$faculty_id = $result_faculty['id'];
$function_type = $postdata['function_type'];

// Check faculty permissions
// $teacher_data = getClassSectionSubjectsAndInChargeRoles($conn_rjllearning, $conn_rjllearning_specific, $institution_id, $userid);
// $check_faculty_status = checkFacultyModuleGranted($function_type, $teacher_data['class_section_subjects'], $teacher_data['class_incharge_roles'], $teacher_data['staff_access_modules'], null, null, null, $conn_rjllearning);
// if($check_faculty_status == false){
//     errorreturn("Access denied: You do not have the required permissions.");
// }
if ($postdata['function_type'] == "update_checkedby_status") {

    $success['data'] =  updateCheckedBy($reminder_id, $userid, $checked, $conn_rjllearning_specific, $institution_id, $branch_id);
    successreturn($success);
}
